unit uXmlParser2; { mk, 12.4.04 }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, xmldom, XMLIntf, StdCtrls, msxmldom, XMLDoc, ComCtrls, oxmldom;

type
  TForm1 = class(TForm)
    XDoc: TXMLDocument;
    bGibaus: TButton;
    OpenDialog1: TOpenDialog;
    tvBaum: TTreeView;
    bZeige: TButton;
    mAusgabe: TMemo;
    bZustaende: TButton;
    bLoesche: TButton;
    bEingaben: TButton;
    bAusgaben: TButton;
    bFue: TButton;
    bFa: TButton;
    procedure bGibausClick(Sender: TObject);
    procedure bZeigeClick(Sender: TObject);
    procedure bZustaendeClick(Sender: TObject);
    procedure bLoescheClick(Sender: TObject);
    procedure bEingabenClick(Sender: TObject);
    procedure bAusgabenClick(Sender: TObject);
    procedure bFueClick(Sender: TObject);
    procedure bFaClick(Sender: TObject);
  private
    procedure zeigeKindKnotenText(knotenname : string);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.bGibausClick(Sender: TObject);
var
  node   : IXMLNode;
  nodes  : IXMLNodeList;
  knoten : TTreeNode;
  s      : string;
  i      : integer;

  procedure erweitere(node : IXMLNode;knoten : TTreeNode);
  var
    nodes      : IXMLNodeList;
    kindknoten : TTreeNode;
    i          : integer;
  begin
    if node.HasChildNodes then
    begin
      nodes := node.ChildNodes;
      for i := 0 to nodes.Count - 1 do
      begin
        case nodes[i].NodeType of
          ntElement   : kindknoten :=
                          tvBaum.Items.AddChild(knoten,'<'+nodes[i].NodeName+'>');
          ntText      : kindknoten :=
                          tvBaum.Items.AddChild(knoten,nodes[i].text);
        end; // of case
        erweitere(nodes[i],kindknoten);
      end;
    end;
  end;

begin
  if OpenDialog1.Execute then
  try
    tvBaum.Items.Clear;
    XDoc.LoadFromFile(OpenDialog1.FileName);
    node := XDoc.DocumentElement;
    nodes := node.AttributeNodes;
    s := '';
    for i := 0 to nodes.Count - 1 do
      s := s + nodes[i].NodeName + ' = ' +nodes[i].NodeValue + '  ';
    knoten := tvBaum.Items.Add(nil,'<'+node.NodeName+'>  '+s);
    erweitere(node,knoten);
  except
    on E:Exception do
      mAusgabe.Lines.Add(E.Message);
  end;
end;

procedure TForm1.bZeigeClick(Sender: TObject);
begin
  if XDoc.Active
  then
    mAusgabe.Lines.Add(XDoc.DocumentElement.Attributes['name'])
end;

procedure TForm1.zeigeKindKnotenText(knotenname : string);
var
  nodes : IXMLNodeList;
  i     : integer;
  s     : string;
begin
  if XDoc.Active
  then
  begin
    nodes := XDoc.DocumentElement.ChildNodes[knotenname].ChildNodes;
    s := '';
    for i := 0 to Nodes.Count-1 do s := s + Nodes[i].Text+ '  ';
    mAusgabe.Lines.Add(s);
  end;
end;

procedure TForm1.bZustaendeClick(Sender: TObject);
begin
  zeigeKindKnotenText('zustandsmenge');
end;

procedure TForm1.bEingabenClick(Sender: TObject);
begin
  zeigeKindKnotenText('eingabemenge');
end;

procedure TForm1.bLoescheClick(Sender: TObject);
begin
  mAusgabe.Lines.Clear;
end;

procedure TForm1.bAusgabenClick(Sender: TObject);
begin
  zeigeKindKnotenText('ausgabemenge');
end;

procedure TForm1.bFueClick(Sender: TObject);
begin
  zeigeKindKnotenText('ueberfuehrungsfunktion');
end;

procedure TForm1.bFaClick(Sender: TObject);
begin
  zeigeKindKnotenText('ausgabefunktion');
end;

end.
